# Hướng dẫn sử dụng scan ips tool.
scanips là ứng dụng viết bằng python để quét các ip của 1 domain, ví dụ như các domain các dịch vụ của google. Việc quét ip này có nhiều mục đích, trong đó có thể dùng để add danh sách ip của các domain tracking code vào DNS Whitelist của các mạng wi-fi marketing tích hợp với AWING để tránh lỗi lệch impression (ko gửi được impression về server tracking)

[[_TOC_]]

## I. Download source code
Để chạy ứng dụng thì ta cần download mã nguồn về máy để chạy, có 2 phương pháp

### 1. Dùng git
Nếu đã biết các sử dụng git thì dùng git để download mã nguồn về

*git clone https://gitlab.awing.vn/awing-public/awing-wifi-tools.git*

Mã nguồn của tool sẽ nằm trong thư mục scanips


### 2. Download thủ công

Nếu không dùng git thì có thể download thẳng source code về máy, cũng tương tự như dùng git

Trong cả 2 trường hợp, giả sử rằng thư mục source code đã download về máy là C:\\scanips\>

## II. Thiết lập thông số

### 1. File app.py

Chứa source code.

### 2. File config.py

Chứa thông số cấu hình :

- domain : Tên domain cần scan.
- filename : Tên file chứa kết quả danh sách IP scan được của lần chạy này, đồng thời là đầu vào cho lần chạy kế tiếp, mặc định là *known_ips.json*. Do đó nếu scan cùng 1 domain thì giữ nguyên tên filename để hệ thống lấy dữ liệu cũ làm đầu vào (danh sách IP đã scan được)
- count : Số lượng lần scan, mỗi lần scan sẽ ra 1 IP (mới hoặc cũ). Đối với domain có ít IP thì có thể đặt count=100 là đủ, còn trường hợp domain có nhiều IP có thể đặt count khá lớn (cỡ 1,000,000)

### 3. File known_ips.json

Chứa danh sách ip đã scan được, lưu ý giữ nguyên nội dung file cho các lần chạy sau để tool chỉ add những ip mới (chưa có trong file). 

## III. Cài đặt và chạy ứng dụng

### 1. Cài đặt python

Để chạy ứng dụng, ta cài đặt python version 3.7 trở lên. Truy cập https://www.python.org/ và tìm gói cài đặt tương ứng, sau khi cài đặt thành công thì kiểm tra xem python đã hoạt động chưa bằng cách mở command và gõ lệnh

*C:\\>python*

Nếu hiển thị thông tin version và dấu nhắc >>> thì nghĩa là đã cài đặt thành công, ví dụ

\>\>\> *Python 3.7.9 (tags/v3.7.9:13c94747c7, Aug 17 2020, 18:58:18) [MSC v.1900 64 bit (AMD64)] on win32*
*Type "help", "copyright", "credits" or "license" for more information.*

### 2. Cài đặt pip

PIP (Preferred Installer Program), là trình quản lý package trên python, đa phần khi cài đặt python thì đã kèm pip, để kiểm tra ta mở command và gõ lệnh

*C:\\>pip -V*

Nếu hiển thị thông tin version nghĩa là đã có sẵn pip

*pip 22.0.4 from D:\Python37\lib\site-packages\pip (python 3.7)*

Ngược lại thì ta phải cài đặt pip, tham khảo và cài đặt tại đường dẫn https://pip.pypa.io/en/stable/installation/

### 3. Cài đặt các gói cần thiết để chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để cài đặt các gói

*C:\\scanips\>pip install -r requirements.txt --no-cache-dir --compile*

### 4. Chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để chạy ứng dụng

*C:\\scanips\>python app.py*

### 5. Chạy lại ứng dụng nhiều lần ở nhiều vị trí địa lý khác nhau

Thực hiện lại bước 4 nhiều lần ở nhiều vị trí địa lý khác nhau (HN, SG, ĐN, ..) để scan được nhiều IP hơn do có khả năng DNS server trả về IP theo dạng Geo-Location