import requests
import json
from os.path import exists
import config

def append_known_ip(filename, ip: str):

    known_ips = read_known_ips(filename)
    known_ips.append(ip)
    known_ips.sort()
    with open(filename, mode="w", encoding='utf_8') as f:  
        json_formatted_str = json.dumps(known_ips, indent=4)
        f.write(json_formatted_str)

def read_known_ips(filename):
    
    if not exists(filename):
        with open(filename, mode="w", encoding='utf_8') as f:  
            f.write(json.dumps([]))

    with open(filename, encoding='utf_8') as f:  
        known_ips = json.load(f)
    
    return known_ips


def scan_ips(filename, dns_server, count, domain):

    print("scan ip for domain "+domain + " with dns_server " + dns_server + " loop "+str(count) + " times !")   
    known_ips = read_known_ips(filename)
    print("init known ips")
    print(json.dumps(known_ips, indent=4))
    headers = {'accept': 'application/dns-json'}
    url = "https://dns.google/resolve?name="+domain
    if(dns_server=="cloudflare"):
        url = "https://1.1.1.1/dns-query?name="+domain
    
    while count>0:
        try:
            if(count%100 == 0):
                print("call next 100 request from backward count="+str(count))
            
            r = requests.get(url, headers=headers)   
            data = json.loads(r.text)
            ip = data['Answer'][0]['data'].strip()
            if ip not in known_ips:
                print('found new ip '+ip)
                known_ips.append(ip)
                append_known_ip(filename,ip)

        except:
            pass    
        
        count=count-1


filename = config.filename
dns_servers = ["google", "cloudflare"]
count = config.count
domain = config.domain

for dns_server in dns_servers:
    scan_ips(filename, dns_server, count, domain)






